import { BaseIdToken, Rule } from './auth-type';
import { AppDomain } from '../type';
import { RoleModel } from '../model';
export declare type RoleMetadata = {
    models: {
        [x: string]: RoleModel;
    };
};
export declare type VerifyIdToken = BaseIdToken & {
    rules?: Rule[];
    rolesMetadata?: RoleMetadata[];
};
export declare const schemaVerifyIdToken: {
    rules: import("joi").ArraySchema<any[]>;
    rolesMetadata: import("joi").ArraySchema<any[]>;
    userId: import("joi").NumberSchema<number>;
    userLogin: import("joi").StringSchema<string>;
    localeCode: import("joi").StringSchema<string>;
    orgId: import("joi").NumberSchema<number>;
    appDomain: import("joi").StringSchema<string>;
    productId: import("joi").NumberSchema<number>;
    extended: import("joi").ObjectSchema<any>;
};
export declare type BearerMetadata = {
    orgId: number;
    appDomain: AppDomain;
    productId: number;
    roleType?: string;
    hasAbility?: Rule;
};
export declare type AuthBearerVerify = (token: string, metadata: BearerMetadata) => Promise<VerifyIdToken>;
export declare type BasicMetadata = {
    username: string;
    password: string;
    orgId: number;
    appDomain: AppDomain;
    productId: number;
    roleType?: string;
    hasAbility?: Rule;
};
export declare type AuthBasicVerify = (metadata: BasicMetadata) => Promise<VerifyIdToken>;
